#!/usr/bin/perl -T
#!/usr/local/bin/perl -T

## --> Mixer IMD Calculator, mixer_imd.cgi
## --> Green Bay Professional Packet Radio, www.gbppr.org

## This file Copyright 2004 <contact@gbppr.org> under the GPL
## NO WARRANTY. Please send bug reports / patches / reports.

# Setup
#
use Math::Complex;
select STDOUT;
$| = 1;
$pic = "pics/mixer_imd.png";

# Print MIME
#
print "Content-type:text/html\n\n";

# Read environment
#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}

my $lo = $FORM{'lo'};

my $rf = $FORM{'rf'};


# Clean up user input data
#
$lo =~ tr/0-9.//csd;

if (!$lo) {
  $lo_mhz = 172; # 172 MHz
}

$rf =~ tr/0-9.//csd;

if (!$rf) {
  $rf_mhz = 144; # 144 MHz
}

# Start calculations
#
# Subtractive Mode:   B - A = IF   B > A  B=LO,A=RF 
#

$rf_mhz = $rf;
$lo_mhz = $lo;

$A = $rf_mhz;
$B = $lo_mhz;

$R = sprintf "%.3f", $rf_mhz / $lo_mhz;

$lo_mhz = sprintf "%.3f", $lo_mhz;
$rf_mhz = sprintf "%.3f", $rf_mhz;
$if_mhz = sprintf "%.3f", $lo_mhz - $rf_mhz;

$date = scalar gmtime;

# Draw me a web page
#
$b = "<font color=\"blue\">";
$p = "<font color=\"purple\">";
$e = "</font>";

print <<EOF;
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html>
<head>
<title>Mixer IMD Calculator Results</title>
</head>
<body bgcolor="#D3D3D3" text="#000000" link="blue">
<center>
<h2>Mixer IMD Calculator Results</h2>
</center>

<hr noshade>
<center><img src="$pic" alt="[mixer imd]"></center>

<pre>
	   $b Mixer LO : $e$lo_mhz$b MHz $e
	   $b Mixer RF : $e$rf_mhz$b MHz $e
	   $b Mixer IF : $e$if_mhz$b MHz $e

                  $p R : $e$R
<br>
EOF

$a = "RF";
$b = "LO";

if ($R > 0.875 && $R <= 1.000) {
   print "<table border=1 cellpadding=4>\n";
   print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

   printf "<tr><td>%.3f MHz</td> <td><b>4th</b> (2%s-2%s)</td></tr>\n", (2 * $B) - (2 * $A), $b, $a;
   printf "<tr><td>%.3f MHz</td> <td><b>6th</b> (3%s-3%s)</td></tr>\n", (3 * $B) - (3 * $A), $b, $a;
   printf "<tr><td>%.3f MHz</td> <td>8th (4%s-4%s)</td></tr>\n", (4 * $B) - (4 * $A), $b, $a;
   printf "<tr><td>%.3f MHz</td> <td>10th (5%s-5%s)</td></tr>\n", (5 * $B) - (5 * $A), $b, $a;
   printf "<tr><td>%.3f MHz</td> <td>12th (6%s-6%s)</td></tr>\n", (6 * $B) - (6 * $A), $b, $a;
   printf "<tr><td>%.3f MHz</td> <td>14th (7%s-7%s)</td></tr>\n", (7 * $B) - (7 * $A), $b, $a;

   print "</table>\n";
}

if ($R > 0.858 && $R <= 0.875) {
   print "<table border=1 cellpadding=4>\n";
   print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

   printf "<tr><td>%.3f MHz</td> <td>13th (7%s-6%s)</td></tr>\n", (7 * $A) - (6 * $B), $a, $b;

   print "</table>\n";
}

if ($R > 0.833 && $R <= 0.858) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>11th (6%s-5%s)</td></tr>\n", (6 * $A) - (5 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>15th (7%s-8%s)</td></tr>\n", (7 * $B) - (8 * $A), $b, $a;
  
  print "</table>\n";
}

if ($R > 0.800 && $R <= 0.833) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>9th (5%s-4%s)</td></tr>\n", (5 * $A) - (4 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>13th (6%s-7%s)</td></tr>\n", (6 * $B) - (7 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.778 && $R <= 0.800) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>7th</b> (4%s-3%s)</td></tr>\n", (4 * $A) - (3 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>11th (5%s-6%s)</td></tr>\n", (5 * $B) - (6 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.750 && $R <= 0.778) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>14th (8%s-6%s)</td></tr>\n", (8 * $A) - (6 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.715 && $R <= 0.750) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";
 
  printf "<tr><td>%.3f MHz</td> <td><b>5th</b> (3%s-2%s)</td></tr>\n", (3 * $A) - (2 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>9th (4%s-5%s)</td></tr>\n", (4 * $B) - (5 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>12th (7%s-5%s)</td></tr>\n", (7 * $A) - (5 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.700 && $R <= 0.715) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>10th (6%s-4%s)</td></tr>\n", (6 * $A) - (4 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>14th (6%s-8%s)</td></tr>\n", (6 * $B) - (8 * $A), $b, $a;
  
  print "</table>\n";
}

if ($R > 0.667 && $R <= 0.700) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>15th (9%s-6%s)</td></tr>\n", (9 * $A) - (6 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.625 && $R <= 0.667) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>3rd</b> (2%s-%s)</td></tr>\n", (2 * $A) - ($B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td><b>7th</b> (3%s-4%s)</td></tr>\n", (3 * $B) - (4 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>8th (5%s-3%s)</td></tr>\n", (5 * $A) - (3 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>12th (5%s-7%s)</td></tr>\n", (5 * $B) - (7 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>13th (8%s-5%s)</td></tr>\n", (8 * $A) - (5 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.600 && $R <= 0.625) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>11th (7%s-4%s)</td></tr>\n", (7 * $A) - (4 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>15th (6%s-9%s)</td></tr>\n", (6 * $B) - (9 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.571 && $R <= 0.600) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>6th</b> (4%s-2%s)</td></tr>\n", (4 * $A) - (2 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>10th (4%s-6%s)</td></tr>\n", (4 * $B) - (6 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>14th (9%s-5%s)</td></tr>\n", (9 * $A) - (5 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.555 && $R <= 0.571) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>9th (6%s-3%s)</td></tr>\n", (6 * $A) - (3 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>13th (5%s-8%s)</td></tr>\n", (5 * $B) - (8 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.545 && $R <= 0.555) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>12th (8%s-4%s)</td></tr>\n", (8 * $A) - (4 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.500 && $R <= 0.545) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>15th (10%s-5%s)</td></tr>\n", (10 * $A) - (5 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.455 && $R <= 0.500) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>1st</b> (%s)</td></tr>\n", $A, $a;
  printf "<tr><td>%.3f MHz</td> <td><b>4th</b> (3%s-%s)</td></tr>\n", (3 * $A) - ($B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td><b>5th</b> (2%s-3%s)</td></tr>\n", (2 * $B) - (3 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td><b>7th</b> (5%s-2%s)</td></tr>\n", (5 * $A) - (2 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>8th (3%s-5%s)</td></tr>\n", (3 * $B) - (5 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>10th (7%s-3%s)</td></tr>\n", (7 * $A) - (3 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>11th (4%s-7%s)</td></tr>\n", (4 * $B) - (7 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>13th (9%s-4%s)</td></tr>\n", (9 * $A) - (4 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>14th (5%s-9%s)</td></tr>\n", (5 * $B) - (9 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.445 && $R <= 0.455) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>14th (10%s-4%s)</td></tr>\n", (10 * $A) - (4 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.429 && $R <= 0.445) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>11th (8%s-3%s)</td></tr>\n", (8 * $A) - (3 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>15th (5%s-10%s)</td></tr>\n", (5 * $B) - (10 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.416 && $R <= 0.429) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>8th (6%s-2%s)</td></tr>\n", (6 * $A) - (2 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>12th (4%s-8%s)</td></tr>\n", (4 * $B) - (8 * $A), $b, $a;;

  print "</table>\n";
}

if ($R > 0.400 && $R <= 0.416) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>15th (11%s-4%s)</td></tr>\n", (11 * $A) - (4 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.375 && $R <= 0.400) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>5th</b> (4%s-%s)</td></tr>\n", (4 * $A) - ($B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>9th (3%s-6%s)</td></tr>\n", (3 * $B) - (6 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>12th (9%s-3%s)</td></tr>\n", (9 * $A) - (3 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.364 && $R <= 0.375) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>9th (7%s-2%s)</td></tr>\n", (7 * $A) - (2 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>13th (4%s-9%s)</td></tr>\n", (4 * $B) - (9 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.333 && $R <= 0.364) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>13th (10%s-3%s)</td></tr>\n", (10 * $A) - (3 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.308 && $R <= 0.333) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>2nd</b> (2%s)</td></tr>\n", (2 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td><b>6th</b> (2%s-4%s)</td></tr>\n", (2 * $B) - (4 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td><b>6th</b> (5%s-%s)</td></tr>\n", (5 * $A) - ($B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>10th (3%s-7%s)</td></tr>\n", (3 * $B) - (7 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>10th (8%s-2%s)</td></tr>\n", (8 * $A) - (2 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>14th (4%s-10%s)</td></tr>\n", (4 * $B) - (10 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>14th (11%s-3%s)</td></tr>\n", (11 * $A) - (3 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.300 && $R <= 0.308) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>15th (12%s-3%s)</td></tr>\n", (12 * $A) - (3 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.286 && $R <= 0.300) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>11th (9%s-2%s)</td></tr>\n", (9 * $A) - (2 * $B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>15th (4%s-11%s)</td></tr>\n", (4 * $B) - (11 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.273 && $R <= 0.286) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>7th</b> (6%s-%s)</td></tr>\n", (6 * $A) - ($B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>11th (3%s-8%s)</td></tr>\n", (3 * $B) - (8 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.250 && $R <= 0.273) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>12th (10%s-2%s)</td></tr>\n", (10 * $A) - (2 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.231 && $R <= 0.250) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>3rd</b> (3%s)</td></tr>\n", (3 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td><b>7th</b> (2%s-5%s)</td></tr>\n", (2 * $B) - (5 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>8th (7%s-%s)</td></tr>\n", (7 * $A) - ($B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>12th (3%s-9%s)</td></tr>\n", (3 * $B) - (9 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>13th (11%s-2%s)</td></tr>\n", (11 * $A) - (2 * $B), $a, $b;
  
  print "</table>\n";
}

if ($R > 0.222 && $R <= 0.231) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>14th (12%s-2%s)</td></tr>\n", (12 * $A) - (2 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.214 && $R <= 0.222) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>9th (8%s-%s)</td></tr>\n", (8 * $A) - ($B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>13th (3%s-10%s)</td></tr>\n", (3 * $B) - (10 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.200 && $R <= 0.214) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>15th (13%s-2%s)</td></tr>\n", (13 * $A) - (2 * $B), $a, $b;

  print "</table>\n";
}

if ($R > 0.182 && $R <= 0.200) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>4th</b> (4%s)</td></tr>\n", (4 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td>8th (2%s-6%s)</td></tr>\n", (2 * $B) - (6 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>10th (9%s-%s)</td></tr>\n", (9 * $A) - ($B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>14th (3%s-11%s)</td></tr>\n", (3 * $B) - (11 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.167 && $R <= 0.182) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>11th (10%s-%s)</td></tr>\n", (10 * $A) - ($B), $a, $b;
  printf "<tr><td>%.3f MHz</td> <td>15th (3%s-12%s)</td></tr>\n", (3 * $B) - (12 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.154 && $R <= 0.167) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>5th</b> (5%s)</td></tr>\n", (5 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td>9th (2%s-7%s)</td></tr>\n", (2 * $B) - (7 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>12th (11%s-%s)</td></tr>\n", (11 * $A) - ($B), $a, $b;

  print "</table>\n";
}

if ($R > 0.143 && $R <= 0.154) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>13th (12%s-%s)</td></tr>\n", (12 * $A) - ($B), $a, $b;

  print "</table>\n";
}

if ($R > 0.133 && $R <= 0.143) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>6th</b> (6%s)</td></tr>\n", (6 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td>10th (2%s-8%s)</td></tr>\n", (2 * $B) - (8 * $A), $b, $a;
  printf "<tr><td>%.3f MHz</td> <td>14th (13%s-%s)</td></tr>\n", (13 * $A) - ($B), $a, $b;

  print "</table>\n";
}

if ($R > 0.125 && $R <= 0.133) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>15th (14%s-%s)</td></tr>\n", (14 * $A) - ($B), $a, $b;

  print "</table>\n";
}

if ($R > 0.111 && $R <= 0.125) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td><b>7th</b> (7%s)</td></tr>\n", (7 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td>11th (2%s-9%s)</td></tr>\n", (2 * $B) - (9 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.100 && $R <= 0.111) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>8th (8%s)</td></tr>\n", (8 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td>12th (2%s-10%s)</td></tr>\n", (2 * $B) - (10 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.091 && $R <= 0.100) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>9th (9%s)</td></tr>\n", (9 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td>13th (2%s-11%s)</td></tr>\n", (2 * $B) - (11 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.083 && $R <= 0.091) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>10th (10%s)</td></tr>\n", (10 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td>14th (2%s-12%s)</td></tr>\n", (2 * $B) - (12 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.077 && $R <= 0.083) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>11th (11%s)</td></tr>\n", (11 * $A), $a;
  printf "<tr><td>%.3f MHz</td> <td>15th (2%s-13%s)</td></tr>\n", (2 * $B) - (13 * $A), $b, $a;

  print "</table>\n";
}

if ($R > 0.072 && $R <= 0.077) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>12th (12%s)</td></tr>\n", (12 * $A), $a;

  print "</table>\n";
}

if ($R > 0.067 && $R <= 0.072) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>13th (13%s)</td></tr>\n", (13 * $A), $a;

  print "</table>\n";
}

if ($R > 0.063 && $R <= 0.067) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>14th (14%s)</td></tr>\n", (14 * $A), $a;

  print "</table>\n";
}

if ($R > 0.000 && $R <= 0.063) {
  print "<table border=1 cellpadding=4>\n";
  print "<tr><th><b>Potential IMD Frequency</b></th><th><b>Order</b></th></tr>\n";

  printf "<tr><td>%.3f MHz</td> <td>15th (15%s)</td></tr>\n", (15 * $A), $a;

  print "</table>\n";
}

print "</pre>\n";
print "<hr noshade size=\"5\">\n";
print "<p><font size=\"-1\">Calculated on $date GMT</font></p>\n";
print "</body>\n";
print "</html>\n";
